/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.command.impl;

import java.util.Iterator;

import org.apache.commons.chain.Catalog;
import org.apache.commons.chain.Command;
import org.apache.commons.chain.impl.CatalogBase;
import org.exoplatform.container.component.ComponentPlugin;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: CommandService.java 5799 2006-05-28 17:55:42Z geaz $
 */

public class CommandService {
  
  protected Catalog catalog;

  public CommandService() {
    catalog = new CatalogBase();
  }
  
  public void addPlugin(ComponentPlugin plugin) {
    if (plugin instanceof CommonsXMLConfigurationPlugin) {
      CommonsXMLConfigurationPlugin cplugin = (CommonsXMLConfigurationPlugin) plugin;
      catalog = cplugin.getCatalog();
    }
      
  }
  
  public void addCommand(String name, Command command) {
    catalog.addCommand(name, command);
  }

  public Command getCommand(String name) {
    return catalog.getCommand(name);
  }

  public Iterator getNames() {
    return catalog.getNames();
  }

  


}
