/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.command;

import java.util.Iterator;

import junit.framework.TestCase;

import org.apache.commons.chain.Context;
import org.apache.commons.chain.impl.ContextBase;
import org.exoplatform.container.StandaloneContainer;
import org.exoplatform.services.command.impl.CommandService;



/**
 * Created by The eXo Platform SARL .
 * 
 * @author <a href="mailto:geaz@users.sourceforge.net">Gennady Azarenkov </a>
 * @version $Id: CommandServiceTest.java 5799 2006-05-28 17:55:42Z geaz $
 */
public class CommandServiceTest extends TestCase {

  private StandaloneContainer container;
  
  public void setUp() throws Exception {
    
    StandaloneContainer.setConfigurationPath("src/java/conf/standalone/test-configuration.xml");
  	
    container = StandaloneContainer.getInstance();
  }
  
  public void testConf() throws Exception {
    
    CommandService cservice = (CommandService)container.getComponentInstanceOfType(CommandService.class);
    assertNotNull(cservice);
    
    // preconfigured commands
    assertTrue(cservice.getNames().hasNext());
    assertNotNull(cservice.getNames().next());
    
  }
  
  public void testExcecute() throws Exception {
    
    CommandService cservice = (CommandService)container.getComponentInstanceOfType(CommandService.class);
    Iterator cs = cservice.getNames();
    String c1 = (String)cs.next();
    String c2 = (String)cs.next();
    
    Context ctx = new ContextBase();
    ctx.put("test", Integer.valueOf(0));
    cservice.getCommand(c1).execute(ctx);
    cservice.getCommand(c2).execute(ctx);
    assertEquals(3, ((Integer)ctx.get("test")).intValue());
    
  }

}
