/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.grammar.wiki.impl;

import org.exoplatform.services.grammar.wiki.WikiContext;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Dec 19, 2004
 * @version $Id: IntrospectionTokenHandler.java 5799 2006-05-28 17:55:42Z geaz $
 */
public class IntrospectionTokenHandler extends TokenHandler {
  
  public Token handleToken(Token parent, Token token, ParsingContext context)  {
    WikiContext wikiContext = context.getWikiContext() ;
    String expression = context.getSubstring(token.start, token.end ) ;
    if(wikiContext == null) {
      context.out(expression) ;
    } else {
      context.out(IntrospectionInfo.inspect(wikiContext, expression)) ;
    }
    return context.nextToken(token) ;
  }
  
  public String[] getHandleableTokenType() { 
    return new String[]{Token.BEAN_INTROSPECTION_TOKEN} ;
  }
}