/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.faces.core.renderer.html;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.servlet.ServletContext;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.context.PortletFacesContext;
import org.exoplatform.faces.core.component.ComponentTemplate;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.services.templates.velocity.StaticResourceLoader;
import org.exoplatform.services.templates.velocity.VelocityService;

public  class VelocityRenderer extends  HtmlBasicRenderer {
	
	public static SimpleDateFormat DateFormatter = new SimpleDateFormat() ;
	
  protected Template getTemplate(UIComponent component, FacesContext fcontext) throws Exception {
    VelocityService vservice =  
      (VelocityService) PortalContainer.getComponent(VelocityService.class) ;
    StaticResourceLoader srloader = vservice.getStaticResourceLoader() ;
    String name = null ;
    String path = null ;
    if(component instanceof ComponentTemplate) {
      path =  ((ComponentTemplate)component).getTemplatePath() ;
      name = path ;
    }  else {
      name =  component.getClass().getName() ;
      path = name.replaceFirst("component", "renderer/html") ;
      path = path.replace('.', '/') + ".vm" ;
    }
    try {
      Template template  = srloader.getTemplate(name) ;
      if(template != null)  return template ;
    } catch(Exception ex) {}
    
    URL url = null ;
    if(fcontext instanceof PortletFacesContext) {
      PortletFacesContext pfcontext =  (PortletFacesContext) fcontext ;
      FacesContext pfContext = pfcontext.getPortalFacesContext() ;
      ServletContext context = (ServletContext) pfContext.getExternalContext().getContext();
      String newPath = context.getRealPath("/portlets/velocity/") ;
      if(newPath != null)srloader.addPath(newPath) ;
      url = getResource(context, "/portlets/velocity/" + path) ;
      //S ystem.out.println("LOAD FROM PORTAL: " + url) ;
    } 
    if(url == null) {
      ServletContext context = (ServletContext) fcontext.getExternalContext().getContext();
      String newPath = context.getRealPath("/velocity/") ;
      if(newPath != null)srloader.addPath(newPath) ;
      url = getResource(context, "/velocity/" + path) ;
      //S ystem.out.println("LOAD FROM PORTLET: " + url) ;
    }
    if(url == null){
      url = Thread.currentThread().getContextClassLoader().getResource(path);
      //S ystem.out.println("LOAD FROM CLASSPATH: " + url) ;
    }
    if(url == null) {
      throw new Exception("Cannot  find the template " + path + " in the search path") ;
    }
    srloader.addTemplate(name, url) ;
    return vservice.getTemplate(name) ;
  }
  
  protected  URL  getResource(ServletContext scontext, String path) throws Exception {
    String realPath = scontext.getRealPath(path ) ;
    URL url = null ;
    if(realPath != null) {
      File file = new File( realPath );   
      if(file.canRead()) url = file.toURL() ;
    }
    if(url == null) {
      url = scontext.getResource( path) ;
    }
    return url ;
  }
  
  public void encodeChildren( FacesContext context, UIComponent component ) throws IOException {
    ResponseWriter w = context.getResponseWriter() ;
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
    try {
      Template template = getTemplate(component, context) ;
      VelocityContext vcontext = new VelocityContext() ;
      vcontext.put(UIExoComponent.UICOMPONENT, component) ;
      vcontext.put("DateFormatter", DateFormatter) ;
      vcontext.put("res", res) ;
      template.merge(vcontext, w) ;
    } catch (Exception ex) {
      w.write("Render  Error: " + ex.getMessage()) ;
      ex.printStackTrace() ;
    }
  }
}
