/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal;

import org.exoplatform.container.ExoContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.container.component.BaseComponentLifecyclePlugin;
import org.exoplatform.portal.config.PortalConfigService;
import org.exoplatform.portal.faces.component.PortalComponentCache;
import org.exoplatform.portal.faces.component.UIPortal;
import org.exoplatform.portal.session.ExoPortal;
import org.exoplatform.portal.session.RequestInfo;
import org.exoplatform.services.organization.OrganizationService;
import org.exoplatform.services.organization.UserProfile;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Jan 11, 2005
 * @version $Id$
 */
public class PortalSessionLifecycle extends BaseComponentLifecyclePlugin {
  public void initComponent(ExoContainer container, Object component) throws Exception {
    SessionContainer scontainer = (SessionContainer) component;
    OrganizationService orgService = 
      (OrganizationService) container.getComponentInstanceOfType(OrganizationService.class);
    UserProfile userProfile = orgService.getUserProfileHandler().findUserProfileByName(scontainer.getOwner());
    if (userProfile == null)
      userProfile = orgService.getUserProfileHandler().createUserProfileInstance();
    container.registerComponentInstance(userProfile.getClass(), userProfile);

    RequestInfo rinfo = new RequestInfo();
    container.registerComponentInstance(rinfo);
    container.registerComponentImplementation(PortalComponentCache.class);
    PortalConfigService configService = 
      (PortalConfigService) container.getComponentInstanceOfType(PortalConfigService.class);
    UIPortal uiportal = new UIPortal(configService, rinfo);
    scontainer.registerComponentInstance(ExoPortal.class, uiportal);
  }
}
