/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.component;

import java.util.List;

import javax.faces.component.UIComponent;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.config.ExoPortletPreferencesPersister;
import org.exoplatform.portal.config.model.PortletPreferences;
import org.exoplatform.portal.config.model.Preference;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISearchForm.java,v 1.4 2004/09/29 17:44:51 benjmestrallet Exp $
 */
public class UIPortletPreferencesForm extends UISimpleForm {
  static String RESTORE_ACTION =  "restore" ;
  static String PREFERENCE = "preference" ;

  UIPortlet  uiPortlet_ ;
  UIComponent returnComponent_ ;
  PortletPreferences preferences_ ;
  
  public UIPortletPreferencesForm() {
    super("portletPreferencesForm", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;
    addActionListener(RestoreActionListener.class, RESTORE_ACTION) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }
  
  public String getPreferencesCreator() { 
    if(preferences_ == null)  return null ;
    String creator = preferences_.getCreator() ;
    if(creator == null) return "system" ;
    return creator  ;
  }
  
  public String getPreferencesModifier() { 
    if(preferences_ == null)  return null ;
    String modifier = preferences_.getModifier() ;
    if(modifier == null) return "system" ;
    return modifier  ;
  }
  
  public void setEditingPortlet(UIComponent returnComponent, UIPortlet uiPortlet) throws Exception {
    returnComponent_ =  returnComponent ;
    ExoPortletPreferencesPersister persister = 
      (ExoPortletPreferencesPersister) PortalContainer.getComponent(ExoPortletPreferencesPersister.class);
    uiPortlet_ =  uiPortlet ;
    preferences_ =  persister.getPortletPreferencesData(uiPortlet.getWindowId()) ;
    List children = getChildren() ;
    children.clear() ;
    if(preferences_ != null) {
      List list = preferences_.getPreferences() ;
      for(int i = 0; i < list.size() ; i++) {
        Preference pref = (Preference) list.get(i) ;
        children.add(new UIPreference(pref)) ;
      }
    }
  }
  
  public String getRestoreAction() { return RESTORE_ACTION ; }
  
  static public class RestoreActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception { 
      UIPortletPreferencesForm uiForm = (UIPortletPreferencesForm) event.getSource() ;
      UIPortal uiPortal = (UIPortal) uiForm.getAncestorOfType(UIPortal.class) ;
      uiPortal.setBodyComponent(uiForm.returnComponent_);
    } 
  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception { 
      UIPortletPreferencesForm uiForm = (UIPortletPreferencesForm) event.getSource() ;
      UIPortal uiPortal = (UIPortal) uiForm.getAncestorOfType(UIPortal.class) ;
      uiPortal.setBodyComponent(uiForm.returnComponent_);
    } 
  }
}