/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.launcher;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.portal.log.UserActivitiesLogService;

/**
 * Created by The eXo Platform SARL        .
 * Date: Jan 25, 2003
 * Time: 5:25:52 PM
 */
public class PortalSessionListener implements HttpSessionListener {
  
  public PortalSessionListener() {
  }
  
  public void sessionCreated(HttpSessionEvent event) {
    
  }

  public void sessionDestroyed(HttpSessionEvent event) {
    HttpSession session = event.getSession() ;
    ServletContext context = session.getServletContext() ;
    PortalContainer pcontainer = PortalContainer.getInstance() ;
    if(pcontainer == null) {
      pcontainer = 
        RootContainer.getInstance().getPortalContainer(context.getServletContextName()) ;
      PortalContainer.setInstance(pcontainer) ;
      close(pcontainer,session) ;
      PortalContainer.setInstance(null) ;
    } else {
      close(pcontainer,session) ;
    }
  }
  
  private void close(PortalContainer pcontainer,HttpSession session) {
    SessionContainer scontainer = 
      pcontainer.getSessionManager().getSessionContainer(session.getId()) ;
    if(scontainer != null) {
      String sessionId = scontainer.getUniqueId() ;
      UserActivitiesLogService uservice_ = 
        (UserActivitiesLogService) pcontainer.getComponentInstanceOfType(UserActivitiesLogService.class) ;
      long currentTime = System.currentTimeMillis() ;
      uservice_.updateLogUserActivities(sessionId, currentTime) ;
      if(scontainer != null)  {
        pcontainer.removeSessionContainer(session.getId()) ;
      }
    }
  }
}