/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlet.faces.component;

import java.util.HashMap;
import java.util.List;
import javax.faces.context.FacesContext;
import org.apache.commons.logging.Log;
import org.exoplatform.faces.core.component.Node;
import org.exoplatform.faces.core.component.UIExoCommand;
/**
 * Wed, Dec 22, 2003 @ 23:14
 *
 * @author: Tuan Nguyen
 * @email: tuan08@users.sourceforge.net
 * @version: $Id: UIPortletPreferences.java,v 1.8 2004/09/22 01:22:50 tuan08 Exp $
 */
public class UIPortletPreferences extends UIExoCommand implements Node {
  final static public String EXECUTE_ACTION = "execute";
  public static final String INPUT = "input";
  public static final String TEXT_AREA = "textarea";
  public static final String SAVE_PREFERENCES = "textarea";

  protected HashMap prefsMap_;
  protected String actionURL_;
  private String tabTitle_;

  public UIPortletPreferences(UIPreferencesForm uiPreferencesForm) {
    setId("UIPortletPreferences");
    setRendererType("PortletPreferencesRenderer");
    FacesContext context = FacesContext.getCurrentInstance();
    actionURL_ = context.getExternalContext().encodeActionURL(null);
    tabTitle_ = "Preferences";

    List children  = getChildren();
    uiPreferencesForm.setRendered(true);
    children.add(uiPreferencesForm);
  }


  public String getName() {
    return tabTitle_;
  }

  public String getIcon() {
    return "no-icon";
  }

  public String getDescription() {
    return "no desc";
  }

  public HashMap getPreferencesMap() {
    return prefsMap_;
  }
}
