/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.display.component;

import java.io.IOException;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.SessionContainer;
import org.exoplatform.faces.core.component.UINode;
import org.exoplatform.portal.config.content.DocumentContent;
import org.exoplatform.portal.config.content.PortalContentService;
import org.exoplatform.portal.session.PortalResources;


/**
 * Created by The eXo Platform SARL
 * Author : Pham Xuan Hoa
 *          phamvuxuanhoa@yahoo.com
 * Mar 2, 2006
 */
public class UIContentDisplay extends UINode {  
  protected DocumentContent documentContent_ ;
  private PortalContentService contentService_ ;
  private String contentId_ ;

  public UIContentDisplay (String id) {
    contentService_ =(PortalContentService) PortalContainer.getComponent(PortalContentService.class) ;
    contentId_ = id ;				
  }  

  public void encodeChildren(FacesContext context) throws IOException {		
    ResponseWriter w = context.getResponseWriter();				
    try {
      documentContent_ = getDocumentContent(contentId_) ;
      w.write("<div class='UIContentDisplay'>");
      if (documentContent_ == null || documentContent_.getContent()== null) {
        w.write("No configuration for the content");
      }else {
        w.write(documentContent_.getContent());
      }
      w.write("</div>");
    }	catch (Exception e) {    
      w.write(e.getMessage()) ;
    }											    								
  }

  private DocumentContent getDocumentContent(String id) throws Exception{
    if(id == null) return null ;
    DocumentContent documentContent = null ;
    if(id.startsWith("war:")||id.startsWith("file://")) {
      if(id.endsWith(".html")) {			
        documentContent = null ;
        documentContent = contentService_.getDocumentById(id) ;
        return documentContent ;
      }            	    			
      PortalResources res = (PortalResources)SessionContainer.getComponent(PortalResources.class);
      String lang = res.getLocaleConfig().getLanguage() ;
      List<DocumentContent> list = contentService_.getDocumentsByGroupId(id) ;
      String tmp = id+"_"+lang+".html" ;		
      for(DocumentContent content:list) {			
        if(content.getId().equals(tmp)) {
          documentContent = content ;				
        }
      }
      if(documentContent == null) {
        tmp = id+"_en.html" ;
        documentContent = contentService_.getDocumentById(tmp) ;
      }				
      return documentContent ;
    }				
    documentContent = contentService_.getDocumentById(id) ;		
    return documentContent ;
  }
}
