/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.validator;

import org.exoplatform.test.web.*;
import com.meterware.httpunit.*;
/**
 * May 21, 2004
 * @author: Thang Nguyen
 * @email:   thangnq@users.sourceforge.net
 * @version: $Id: ExpectFormIdValidator.java
 **/
public class ExpectFormIdValidator implements Validator {
  private String formId_ ;
  
  public ExpectFormIdValidator(String formId) {
    formId_ = formId ;
  }
  
  public boolean validate(WebResponse response, ExoWebClient client) throws Exception {
  	WebForm form = Util.findFormWithId(response, null, formId_) ;
    if(form == null) return false ;
    return true ;
  }
  
  public String getName() { return "ExpectFormIdValidator" ; }
  
  public String getDescription()  {  
    return  "Make sure that the return xhtml  has  the  form with the Id '" +  formId_  + "'" ;
  }
}