/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package control;

import java.util.Map ;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.test.web.* ;
import org.exoplatform.test.web.servlet.* ;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Dec 21, 2005
 */
public class RunTest extends ActionHandler {
  private String DEFAULT_SUITE = "suites.web.CheckAllLinkSuite" ;
  
  public void execute(HttpServletRequest request, HttpServletResponse response) {
    WebappGroovyResourceManager resManager = getResourceManager() ;
    Map  binding =  resManager.createDefaultBinding(request) ;
    String subaction = request.getParameter("subaction") ;
    def config = getConfiguration() ;
    def client = config.getWebClient() ;
    def  suites = client.getTestSuites() ;
    if(suites == null) {
      suites = config.getTestSuites(resManager, DEFAULT_SUITE) ;
      client.setSuites(suites) ;
    }        
    if("nextUnit".equals(subaction)) {
      if(suites.nextUnit()) {
        client.executeUnit(suites.getCurrentWebUnit()) ;
        binding.put("resultData", client.getResponseText());
      } else {
        binding.put("resultData", "test reach the end, click  reset to rerun the test");
      }
      resManager.merge(response.getWriter(), "templates/result.groovy", binding);
    } else if("setBreakPoint".equals(subaction)) {
      String unitId = request.getParameter("unitId") ;
      if(unitId != null) {
        int id =  Integer.parseInt(unitId) ;
        def webunit =  suites.findWebUnit(id) ;
        if(webunit != null)  webunit.setStop(!webunit.isStop()) ;
      }
      binding.put("suites", suites);
      resManager.merge(response.getWriter(), "templates/BreakPoint.groovy", binding);  
    } 
    else if("run".equals(subaction)) {
      client.runTo(suites) ;        
      binding.put("suites", suites);
      resManager.merge(response.getWriter(), "templates/RunTest.groovy", binding);
    } else if("showUnitLastResult".equals(subaction)) {
      String unitId = request.getParameter("unitId") ;
      String result = null ;
      if(unitId != null) {
        int id =  Integer.parseInt(unitId) ;
        def webunit =  suites.findWebUnit(id) ;
        if(webunit != null)  result = webunit.getLastResponseText() ;
        if(result == null )  result = "NO DATA IS AVAILABLE" ; 
      }
      binding.put("resultData", result);
      resManager.merge(response.getWriter(), "templates/result.groovy", binding);
    } else if("reset".equals(subaction)) {
      binding.put("suites", suites);
      suites.reset()  ;
      client.setName(Integer.toString(new Object().hashCode())) ;
      resManager.merge(response.getWriter(), "templates/RunTest.groovy", binding);
    } else if("showSuiteSummary".equals(subaction)) {
      binding.put("suites", suites);
      resManager.merge(response.getWriter(), "templates/SuitesInfo.groovy", binding);    
    } else if("showUnitResult".equals(subaction)) {
      binding.put("resultData", client.getResponseText());
      resManager.merge(response.getWriter(), "templates/result.groovy", binding);
    } else if("showUnitSummary".equals(subaction)) {
    String unitId = request.getParameter("unitId") ;
      def unit = null ;
      if(unitId != null) {
        int id =  Integer.parseInt(unitId) ;
        unit =  suites.findWebUnit(id) ;
      } else {
      	unit = suites.getCurrentWebUnit() ;
      }
      if(unit != null) {
        binding.put("unit", unit);
      }
      resManager.merge(response.getWriter(), "templates/UnitInfo.groovy", binding);    
    } else {
      binding.put("suites", suites);
      resManager.merge(response.getWriter(), "templates/RunTest.groovy", binding);
    }
  }
}