/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserViewNodePropertiesSuite extends WebUnitSuite {
  static String DESC = "Go to View Node Properties page and test all the basic actions" ;
  static String NAME = "UserViewNodePropertiesSuite" ;
  String COMMENT = "you must run AdminManageTaxonomySuite before run this suite";
  
  public UserViewNodePropertiesSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());    
    //-----Select Info tab
    addWebUnit(
      new ClickURLLinkUnit("SelectInfoTab", "click on info tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Info").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewReferences")).         
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewNodeType")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewPermissions")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewProperties"))
    ) ;
    //-----View Node Properties
    addWebUnit(
      new ClickURLLinkUnit("ViewNodeProperties", "click on View Node Properties button").
      setURL("&uicomponent=UIToolbar&op=viewProperties").        
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPropertiesManager&op=selectNode&objectId=UIPropertiesInfo"))       
    ) ;  
    addWebUnit(
        new ClickURLLinkUnit("SelectPropertiesTab", "click on Properties tab").
        setURL("uicomponent=UIPropertiesManager&op=selectNode&objectId=UIPropertiesInfo").        
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPropertiesInfo&op=addProperty"))       
      ) ;  
    addWebUnit(
      new ClickURLLinkUnit("AddProperty", "click on Add Property button").
      setURL("&uicomponent=UIPropertiesInfo&op=addProperty").      
      addValidator(new ExpectFormIdValidator("propertyForm"))      
    ) ;        
    //Select property type
    addWebUnit(
      new SubmitFormUnit("SelectProperty", "click on save button").
      setFormId("propertyForm").
      setField("type","4").        
      setField("op","changeType")        
    ) ;
    //---------------Save Property    
    addWebUnit(
      new SubmitFormUnit("SaveProperty", "click on save button").
      setFormId("propertyForm").
      setField("name","property-test").  
      setField("type","1").
      setField("value","1000").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPropertiesInfo&op=addProperty"))      
    ) ;    
    addWebUnit(
        new ClickURLLinkUnit("ClickOnMetadataTab", "Click on Metadata Tab").
        setURL("uicomponent=UIPropertiesManager&op=selectNode&objectId=UIMetadataFormController").                  
        addValidator(new ExpectFormIdValidator("uiMetadataForm"))
    ) ;
    addWebUnit(
        new SubmitFormUnit("SelectMetadataType", "Select metadata type is mix:referenceable").
        setFormId("uiSelectMetadataForm").         
        setField("metadataType","mix:referenceable").       
        setField("op","changeMetadata").
        addValidator(new ExpectTextValidator("uuid"))         
    ) ;
    addWebUnit(
        new SubmitFormUnit("ReSelectMetadataType", "Select metadata type is dc:elementSet").
        setFormId("uiSelectMetadataForm").         
        setField("metadataType","dc:elementSet").       
        setField("op","changeMetadata").
        addValidator(new ExpectTextValidator("title"))         
    ) ;
    addWebUnit(
        new SubmitFormUnit("SaveMetadata", "Click on save icon to save metadata").
        setFormId("uiMetadataForm").         
        setField("title","testMetadata").       
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIPropertiesManager&op=selectNode&objectId=UIPropertiesInfo"))         
    ) ;
    addWebUnit(
        new ClickURLLinkUnit("ClickOnPropertiesTab", "Click on Properties Tab").
        setURL("uicomponent=UIPropertiesManager&op=selectNode&objectId=UIPropertiesInfo").                  
        addValidator(new ExpectTextValidator("testMetadata")).
        addValidator(new ExpectTextValidator("dc:title")).
        addValidator(new ExpectLinkWithURLValidator("uicomponent=MainToolbar&op=selectWorkspace"))
    ) ;
    //-----Save session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;   
    //-----Refresh session
    addWebUnit(
      new ClickURLLinkUnit("RefreshSession", "click on Refresh Session button").
      setURL("&uicomponent=MainToolbar&op=refreshSession").  
      addValidator(new ExpectTextValidator("The session has been refreshed successfuly"))      
    ) ; 
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;           
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}