/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.share ;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.unit.NewSessionUnit;
import org.exoplatform.test.web.validator.*;
/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: NewAccountSuite.java,v 1.1 2004/10/11 23:27:29 tuan08 Exp $
 **/
public class NewAccountSuite extends WebUnitSuite {
  static String DESC="Create a new user account";
  static String NAME="NewAccountSuite";
    
  public NewAccountSuite() {
    super(NAME, DESC);        
    addWebUnit(
      new NewSessionUnit("NewSession", "Create new session and go to the home page for the first time")
    );        
    addWebUnit(
      new ClickLinkWithText("GoToMyPortalPage", "Tell the web client click on the My Portal page").      
      setTextLink("My Portal").
      addValidator(new ExpectTextValidator("New Account"))
    ) ;        
    addWebUnit(
      new SubmitFormUnit("CreateNewAccount", "Create exoplatform account").
      setFormId("accountForm").
      setField("username", "#{client.name}").
      setField("password1x", "#{client.name}").
      setField("password2x", "#{client.name}").
      setField("firstname", "#{client.name}").
      setField("lastname", "#{client.name}").
      setField("email", "user@localhost.net").
      setField("op","save").
      addValidator(new ExpectTextValidator("New user has been created")) 
    ) ;    
  }  
  public NewAccountSuite(String userName , String password) {
    super(NAME, DESC);        
    addWebUnit(
      new SubmitFormUnit("CreateNewAccount", "Create exoplatform account").
      setFormId("accountForm").
      setField("username", userName).
      setField("password1x", password).
      setField("password2x", password).
      setField("firstname", userName).
      setField("lastname", userName).
      setField("email", "user@localhost.net").
      setField("op","save").
      addValidator(new ExpectTextValidator("New user has been created")) 
    ) ;    
  }
}