;NSIS Modern User Interface version 1.70

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;General

  ;Name and file
  Name "eXo Platform 1.0"
  OutFile "exoplatform-1.0.exe"

  ;Default installation folder
  InstallDir "C:\exoplatform-1.0"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\exoplatform" ""

;--------------------------------
;Interface Settings

  !define EXOPLATFORM_DIR "D:\java\exo-tomcat"

  !define MUI_ICON   "exo_install.ico"
  !define MUI_UNICON "exo_uninstall.ico"

  !define MUI_HEADERIMAGE 
  !define MUI_HEADERIMAGE_BITMAP "exo-platform-logo-200x75.bmp"

  !define MUI_WELCOMEFINISHPAGE_BITMAP    "exo-platform-logo-2.bmp"
  !define MUI_UNWELCOMEFINISHPAGE_BITMAP  "exo-platform-logo-2.bmp"

  !define MUI_BGCOLOR FAFAFA

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_LICENSE "License.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH
  
  !insertmacro MUI_UNPAGE_WELCOME
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  !insertmacro MUI_UNPAGE_FINISH
    
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "portal" SecPortal

  SetOutPath "$INSTDIR"
  
  ;Files...
  File  ${EXOPLATFORM_DIR}\*
  File /r ${EXOPLATFORM_DIR}\bin
  File /r ${EXOPLATFORM_DIR}\common
  File /r ${EXOPLATFORM_DIR}\conf
  File /r ${EXOPLATFORM_DIR}\server
  File /r ${EXOPLATFORM_DIR}\webapps   
    
  ;Create shortcuts
  CreateDirectory "$SMPROGRAMS\eXo Platform"
  CreateShortCut "$SMPROGRAMS\eXo Platform\Start eXo Platform.lnk" "$INSTDIR\bin\startup.bat" 
  CreateShortCut "$SMPROGRAMS\eXo Platform\Stop eXo Platform.lnk" "$INSTDIR\bin\shutdown.bat" 
  CreateShortCut "$SMPROGRAMS\eXo Platform\Startup page.lnk" "http://localhost:8080/portal"
  CreateShortCut "$SMPROGRAMS\eXo Platform\eXo Platform Home Page.lnk" "http://www.exoplatform.com/"
  CreateShortCut "$SMPROGRAMS\eXo Platform\Uninstall eXo Platform.lnk" "$INSTDIR\Uninstall.exe"
  
  ;Store installation folder
  WriteRegStr HKCU "Software\exoplatform" "" $INSTDIR
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

SectionEnd


;Descriptions

  ;Language strings
  LangString DESC_SecPortal ${LANG_ENGLISH} "The eXo Platform portal"

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecPortal} $(DESC_SecPortal)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END


;--------------------------------
;Uninstaller Section

Section "Uninstall"

  RMDir /r "$SMPROGRAMS\eXo Platform"
  RMDir /r $INSTDIR

  Delete "$INSTDIR\Uninstall.exe"

  DeleteRegKey /ifempty HKCU "Software\exoplatform"

SectionEnd